"use strict";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const Bluebird = require('bluebird');
const Etcd = require('node-etcd');
const Symvasi = require('symvasi-runtime');
class EtcdAnnouncer extends Symvasi.AAnnouncer {
    constructor(serviceName, etcdUrl) {
        super(serviceName);
        this.client = Bluebird.promisifyAll(new Etcd(etcdUrl));
    }
    register(endpoint) {
        return __awaiter(this, void 0, void 0, function* () {
            let savedEndpoint = endpoint.save();
            let decodedData = savedEndpoint.data.toString('utf8');
            yield this.client.setAsync(`/symvasi/endpoints/${ this.serviceName }/${ savedEndpoint.id }`, decodedData, { ttl: 20 });
        });
    }
}
exports.EtcdAnnouncer = EtcdAnnouncer;
//# sourceMappingURL=announcer.js.map
