"use strict";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const _ = require('lodash');
const Bluebird = require('bluebird');
const Etcd = require('node-etcd');
const Symvasi = require('symvasi-runtime');
class EtcdDiscoverer extends Symvasi.ADiscoverer {
    constructor(endpointFactory, serviceName, etcdUrl) {
        super(endpointFactory, serviceName);
        this.client = Bluebird.promisifyAll(new Etcd(etcdUrl));
    }
    loadEndpoints() {
        return __awaiter(this, void 0, void 0, function* () {
            let response = yield this.client.getAsync(`/symvasi/endpoints/${ this.serviceName }`);
            return _.map(response.node.nodes, node => {
                let encodedData = new Buffer(node.value);
                return this.endpointFactory.load(encodedData);
            });
        });
    }
}
exports.EtcdDiscoverer = EtcdDiscoverer;
//# sourceMappingURL=discoverer.js.map
